
function power_stats(data)
{
  var npoints = 1;

  var stats = [];
  stats['average'] = data[0][1];
  stats['kwh'] = 0;

  for (var i=1; i<data.length; i++)
  {
    var time_diff  = data[i][0] - data[i-1][0];	// Note: in milliseconds
    var joules_inc = data[i][1] * (time_diff/1000);
    stats['kwh'] += (joules_inc/3600000);
    stats['average'] += data[i][1];
    npoints++;
  }
  stats['kwh'] = Math.abs(stats['kwh']);
  stats['average'] = stats['average'] / npoints;

  return stats;
}

function power_mkt(data)
{
  var	conv = 273.15;          // korekcijaa za racunanje u kelvin
  var gasconst = 8.314472;    // univerzalna gasna konstanta 
  var deltah = 10 * gasconst;    // toplinska aktivacija za proces degradacije 
   
  var npoints = 0;

  var stats = [];
  
  var avertemp = 1*data[0][1];
  stats['average'] = 1*data[0][1];
 
  stats['mktk'] = Math.exp(-deltah / (gasconst * (1*data[0][1] + conv)));

  for (var i=1; i<data.length; i++)
  {
    var time_diff  = (1*data[i][0] - 1*data[i-1][0])/1000;	// Note: in milliseconds
    //var joules_inc = data[i][1] * (time_diff/1000);
    
    stats['average'] += 1*data[i][1];
    var ave_kel = ((1*data[i][1]+1*data[i-1][1])/2)+conv;
    stats['mktk'] += Math.exp(-deltah / (gasconst * ave_kel));

    npoints++;
  }

  stats['mktk'] = (deltah / gasconst) / (-Math.log(stats['mktk'] / i));

  stats['mktc'] = stats['mktk'] -conv;
  stats['average'] = stats['average'] / i;
  stats['mktdp'] = i;
  return stats;
}
